kind: ConfigMap
apiVersion: v1
metadata:
  name: vault-cm
  namespace: {{.Release.Namespace}}
data:
  config.json: |
    {
      "ui": true,
      "listener": {
          "tcp": {
              "address": "0.0.0.0:8200",
          }
      },
      "storage": {
          "consul": {
              "address": "https://consul:8500",
              "path": "vault",
          }
      }
    }
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: vault-deployment
  namespace: {{.Release.Namespace}}
  labels:
    app: vault
spec:
  replicas: 1
  selector:
    matchLabels:
      app: vault
  template:
    metadata:
      labels:
        app: vault
    spec:
      containers:
        - name: vault
          image: {{.Values.image.vault}}
          volumeMounts:
            - name: vault-json-config
              mountPath: /vault/config/config.json
              subPath: config.json
          ports:
            - containerPort: 8200
          env:
            - name: VAULT_DISABLE_MLOCK
              value: "true"
            - name: VAULT_API_ADDR
              value: https://vault.:8200
          command: ["vault", "server", "-config", "/vault/config/config.json"]
      restartPolicy: Always
      volumes:
        - name: vault-json-config
          configMap:
            name: vault-cm
        - name: vault-tls-certificates
          secret:
            secretName: vault-cert-secret
---
apiVersion: v1
kind: Service
metadata:
  name: vault
  namespace: {{.Release.Namespace}}
spec:
  selector:
    app: vault
  type: ClusterIP
  ports:
  - name: https
    port: 8200
    targetPort: 8200
    protocol: TCP